/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.  *
 **************************************************************************/
package org.exoplatform.portlets.weather.renderer.html;

import java.util.Map;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.exoplatform.faces.core.component.model.*;
import org.exoplatform.faces.core.renderer.html.HtmlBasicRenderer;
import org.exoplatform.portlets.weather.component.UISelectList;

public class SelectListRenderer extends HtmlBasicRenderer {
  
  public void decode(FacesContext context, UIComponent component) {
    UISelectList uiList = (UISelectList) component;
    Map paramMap = context.getExternalContext().getRequestParameterMap();
    
    String value = (String) paramMap.get(uiList.getName()) ;
    if (value != null) {
      uiList.setValue(value);
    }
  }
  
  public void encodeBegin(FacesContext context, UIComponent component) throws IOException {
    UISelectList uiList = (UISelectList) component;
    ResponseWriter w = context.getResponseWriter() ;
    String disabled = "" ;
    
    if(!uiList.isEditable()) disabled =  "disabled " ;
    w.write("<select "); w.write(disabled); w.write("name='"); w.write(uiList.getName()); w.write("'") ;
    w.write(" id='"); w.write(uiList.getName()); w.write("'") ;
    
    if(uiList.getClazz() != null) {
      w.write(" class='"); w.write(uiList.getClazz()); w.write("'") ;
    }
    
    w.write(">\n") ;
    
    for(int i=0; i < uiList.getOptions().size(); i++) {
      SelectItem si = (SelectItem) uiList.getOptions().get(i) ;
      if (si.value_.equals(uiList.getValue())) {
        w.write("<option selected value=\""); w.write(si.value_); w.write("\">"); 
        w.write(si.display_); w.write("</option>\n");
      } else {
        w.write("<option value=\""); w.write(si.value_); w.write("\">"); 
        w.write(si.display_); w.write("</option>\n");
      }
    }
    
    w.write("</select>\n") ;
  }
  
  public void encodeChildren(FacesContext context, UIComponent component) throws IOException {
  }
  
  public void encodeEnd(FacesContext context, UIComponent component) throws IOException {
  }
}